import java.sql.*;
import oracle.sql.*;
import oracle.jdbc.driver.*;
import java.io.*;

class blobinsert {
  public static void main(String argv[]) {
    try {
      String url = "jdbc:oracle:thin:@aspen.csit.fsu.edu:1521:aspen";
      String query, condition;
      int	i;

      Class.forName( "oracle.jdbc.driver.OracleDriver" ); 

      System.out.println("Please enter information to connection to the database");
      String user;
      String password;

      user = readEntry ("user: ");
      password = readEntry ("password: ");

      Connection conn = 
        DriverManager.getConnection(url, user, password);
      conn.setAutoCommit (false);

      Statement stat = conn.createStatement();

      BLOB blob;
      
      stat.execute ("INSERT INTO xmltest VALUES (1, empty_blob())");

      query = "select * from xmltest where id=1 for update";
      ResultSet rs = stat.executeQuery(query);
      if ( rs.next() ) {
        blob = ((OracleResultSet)rs).getBLOB(2);
System.out.println("getBLOB");
      File binaryFile = new File("car1.xml");
      System.out.println("car1.xml length = " + binaryFile.length());
      FileInputStream instream = new FileInputStream(binaryFile);
      OutputStream outstream = blob.getBinaryOutputStream();
System.out.println("getBinaryOutputStrem");
      int size = blob.getBufferSize();
      byte[] buffer = new byte[size];
      int length = -1;
System.out.println("buffer");
      while ((length = instream.read(buffer)) != -1)
        outstream.write(buffer, 0, length);
System.out.println("instream read");
      instream.close();
      outstream.close();
      }
      /*while ( rs.next() ) {
	String s1 = rs.getString(1);
	System.out.println(s1+"*");
      }*/
      if (rs != null) rs.close();
      if (stat != null) stat.close();
      if (conn != null) conn.close();
      System.out.println("End of xmlinsert");
    } catch ( Exception e ) {
      System.err.println("Exception: "+e);
      e.printStackTrace();
    }
  }

  static String readEntry (String prompt) {
    try {
      StringBuffer buffer = new StringBuffer();
      System.out.print (prompt);
      System.out.flush();
      int c = System.in.read();
      while (c != '\n' && c !=-1) {
        buffer.append ((char)c);
        c = System.in.read();
      }
      return buffer.toString().trim();
    }
    catch (IOException e) {
      return "";
    }
  }
}
